<?php
//********************************************************************
//* Piccy-Cabinet                                                    *
//* Copyright (c) Album-System All rights Reserved.                  *
//* url:http://www.album-system.com/                                 *
//* e-mail:webmaster@album-system.com                                *
//* Create：2007-03-01(Bata1)                                        *
//* Update：2007-06-10(Bata2)                                        *
//* Update：2007-06-30(0.1.00)                                       *
//********************************************************************
//================================================================

//画像作成非同期処理(ZIP用)
//認証ロジック読み込み(行わない)コマンド実行の為行わない。

//PEARパッケージ読み込み
require_once("File/Archive.php");

//コンフィグファイル読み込み
require_once("config_common.php");
//SQLモジュール読み込み
require_once("db_common.php");
//ログモジュール読み込み
require_once("logger.php");
//共通関数モジュール読み込み
require_once("common.php");


//================================================================
//メイン処理
if ($argc != 5 || in_array($argv[1], array('--help', '-help', '-h', '-?'))){
?>

本スクリプトは、コマンドライン実行を想定したスクリプトです。
処理内容は、以下のとおり。
１、ZIPファイル解凍　
２、ZIPファイル作成（動的ファイルダウンローダ作成により本機能ドロップ）
３、サムネイル作成
４、Exif情報取得
５、ZIPファイルをDB登録
６、写真をDB登録
７、関連ファイル削除

※テンポラリのファイルを操作し、実行後関連ファイルを削除するスクリプトである為、
　アクセス制限などは、特に行わない。

  使用法:
  <?php echo $argv[0]; ?> <option>

  <option> は、$cat_id $album_id $zip_file_name $user_idの4つを指定する。
  --help, -help, -h, あるいは -? を指定すると、
  このヘルプが表示されます。

<?php
} else {
	$target_basedir = $ConfigArray["root"]["album_config"]["PHOTO"]["save_dir"]."/".$argv[1]."_".$argv[2];
	$zip_file_name = $argv[3];
	
	//DB接続
	$Conn = db_conn();
	if(!$Conn){
		log_message(9000,"function(db_conn) DB接続で失敗");
		error_exit(0);
	}

	//PHP実行時間の上限を無制限に変更
	set_time_limit ( 0 );
	
	//WORKディレクトリ作成
	if(!mkdir( $target_basedir."/".WORK_DIR_NAME , 0777)){
		log_message(8001," dir=".$target_basedir);
		error_exit(0);
	}
	
	//１、ZIPファイル解凍
	$zip_path = $target_basedir."/".$zip_file_name;
	File_Archive::extract(
		File_Archive::read($zip_path."/"),
		File_Archive::appender($target_basedir."/".WORK_DIR_NAME."/")
	);
	
	//解凍後ファイル収集処理
	if(!gather_image_file($target_basedir."/".WORK_DIR_NAME, $target_basedir."/".ORIGINAL_DIR_NAME)){
		error_exit(0);
	}
	
	//２、ZIPファイル作成
/*	echo "ZIPファイル作成処理開始\n";
	$create_zip_path = $target_basedir."/".ZIP_DIR_NAME."/".ZIP_FILE_NAME;
	File_Archive::extract(
		File_Archive::read($target_basedir."/".ORIGINAL_DIR_NAME."/"),
		File_Archive::toArchive($create_zip_path, File_Archive::toFiles())
	);*/
	
	//３、サムネイル作成
	$file_list_array = gather_file_list($target_basedir."/".ORIGINAL_DIR_NAME);
	if(!$file_list_array){
		error_exit(0);
	}
	
	//配列をファイル名でソート
	asort($file_list_array, SORT_STRING);
	
	foreach ($file_list_array as $key=>$val){
		//拡張子がJPGであるか確認
		$path_parts = pathinfo($val);
		if(strcasecmp("JPG",$path_parts["extension"]) == 0){
			if(!create_photo($argv[1], $argv[2], $val, $argv[4])){
			}
		}
	}	
	
	//６、WORKディレクトリ削除
	delete_dir($target_basedir."/".WORK_DIR_NAME);
	
	//Todo アップロードファイル削除
	
	//Todoログ
	log_message(1017,"アルバム名=".$argv[1]."_".$argv[2]);
	
	db_close();
}

//error_exit関数
function error_exit($ret){
	log_message(9000,"function(error_exit) ret:".$ret);
	
	global $argv;
	global $target_basedir;
	
	switch ($ret) {
		case 0:
			delete_dir($target_basedir);
			db_del_album_id($argv[1], $argv[2]);
			db_drop_photo_table($argv[1], $argv[2]);
			break;
		case 1:
			//	disp_initial("go_initial");
			break;
		default:
			log_message(9999,"");
	}
	
	//DBコネクションクローズ
	db_close();
	exit($ret);
}

?>
