<?
//********************************************************************
//* Piccy-Cabinet                                                    *
//* Copyright (c) Album-System All rights Reserved.                  *
//* url:http://www.album-system.com/                                 *
//* e-mail:webmaster@album-system.com                                *
//* Create：2007-03-01(Bata1)                                        *
//* Update：2007-06-10(Bata2)                                        *
//* Update：2007-06-30(0.1.00)                                       *
//********************************************************************
//================================================================
//PEARパッケージ読み込み
require_once("DB.php");
//コンフィグファイル読み込み
require_once("config_common.php");
//ログモジュール読み込み
require_once("logger.php");

function db_conn_initial($type, $user, $pass, $host, $db_name){
	global $Conn;
	
	$dsn = $type.
		"://".$user.
		":".$pass.
		"@".$host.
		"/".$db_name;
		
	$Conn = DB::connect($dsn);
	if(DB::isError($Conn)){
		log_message(5001,"errorMessage=".DB::errorMessage($Conn));
		return false;
	}
	log_message(9000,"DBコネクション成功".$Conn->toString());
	return $Conn;
}

function db_conn(){
	global $ConfigArray;
	global $Conn;
	
	$dsn = $ConfigArray["root"]["album_config"]["DB"]["type"].
		"://".$ConfigArray["root"]["album_config"]["DB"]["user"].
		":".$ConfigArray["root"]["album_config"]["DB"]["pass"].
		"@".$ConfigArray["root"]["album_config"]["DB"]["host"].
		"/".$ConfigArray["root"]["album_config"]["DB"]["db_name"];
		
	$Conn = DB::connect($dsn);
	if(DB::isError($Conn)){
		log_message(5001,"errorMessage=".DB::errorMessage($Conn));
		return False;
	}
	log_message(9000,"DBコネクション成功".$Conn->toString());
	
	return $Conn;
}

function db_close(){
	global $Conn;
	
	if($Conn){
		$Conn->disconnect();
		log_message(9000,"DBクローズ");
	}
}

function db_query($sql){
	global $Conn;
	
	log_message(9000,"DBクエリー開始sql=".cnv_dispstr($sql));
	
	$res = $Conn->query($sql);
	if(DB::isError($res)){
		log_message(5002,"errorMessage=".DB::errorMessage($res));
		log_message(5004,"DBクエリー失敗sql=".cnv_dispstr(substr($sql, 0 ,1024)));
		return False;
	}
	log_message(9000,"DBクエリー成功");
	return $res;
}

function db_create_user_table(){
	$sql = "create table user_table (
		user_id INT UNSIGNED PRIMARY KEY AUTO_INCREMENT,
		user_name VARCHAR(64) UNIQUE NOT NULL,
		user_pass VARCHAR(32) NOT NULL,
		user_auth VARCHAR(10) NOT NULL,
        user_cat_view_sort INT UNSIGNED NOT NULL,
        user_album_view_sort INT UNSIGNED NOT NULL,
        user_photo_view_sort INT UNSIGNED NOT NULL,
        user_select_template VARCHAR(64) NOT NULL,
        user_last_access_time DATETIME,
		user_create_time DATETIME,
		user_update_time DATETIME
		)";
	return db_query($sql);
}

function db_drop_user_table(){
	$sql = "drop table if exists user_table";
	return db_query($sql);
}

function db_insert_user($user_name, $user_pass, $user_auth, $user_cat_view_sort, $user_album_view_sort,
    $user_photo_view_sort, $user_select_template, $user_last_access_time, $user_create_time, $user_update_time){
	$sql = "insert into user_table (user_name, user_pass, user_auth, user_cat_view_sort, user_album_view_sort,
    user_photo_view_sort, user_select_template, user_last_access_time, user_create_time, user_update_time)";
	$sql .= "values(\"".cnv_sqlstr($user_name)."\", \""
				.md5(cnv_sqlstr($user_pass))."\", \""
				.cnv_sqlstr($user_auth)."\", \""
                .cnv_sqlstr($user_cat_view_sort)."\", \""
                .cnv_sqlstr($user_album_view_sort)."\", \""
                .cnv_sqlstr($user_photo_view_sort)."\", \""
                .cnv_sqlstr($user_select_template)."\", \""
                .cnv_sqlstr($user_last_access_time)."\", \""
				.cnv_sqlstr($user_create_time)."\", \""
				.cnv_sqlstr($user_update_time)."\")";
	return db_query($sql);
}

function db_update_user_name_auth($user_id, $user_name, $user_auth, $user_update_time){
	$sql = "update user_table set ";
	$sql .= "user_name = \"".cnv_sqlstr($user_name)."\", 
			user_auth = \"".cnv_sqlstr($user_auth)."\",
			user_update_time = \"".cnv_sqlstr($user_update_time)."\"
			where user_id = ".cnv_sqlstr($user_id);
	return db_query($sql);
}

function db_update_user_4_admin($user_id, $user_name, $user_auth, $user_select_template
				, $user_cat_view_sort, $user_album_view_sort,$user_photo_view_sort, $user_update_time){
	$sql = "update user_table set ";
	$sql .= "user_name = \"".cnv_sqlstr($user_name)."\", 
			user_auth = \"".cnv_sqlstr($user_auth)."\",
			user_select_template = \"".cnv_sqlstr($user_select_template)."\",
			user_cat_view_sort = \"".cnv_sqlstr($user_cat_view_sort)."\",
			user_album_view_sort = \"".cnv_sqlstr($user_album_view_sort)."\",
			user_photo_view_sort = \"".cnv_sqlstr($user_photo_view_sort)."\",
			user_update_time = \"".cnv_sqlstr($user_update_time)."\"
			where user_id = ".cnv_sqlstr($user_id);
	return db_query($sql);
}

function db_update_user_config($user_id, $user_select_template, $user_cat_view_sort, $user_album_view_sort, 
			$user_photo_view_sort,$user_update_time){
	$sql = "update user_table set ";
	$sql .= "user_select_template = \"".cnv_sqlstr($user_select_template)."\", 
			user_cat_view_sort = \"".cnv_sqlstr($user_cat_view_sort)."\", 
			user_album_view_sort = \"".cnv_sqlstr($user_album_view_sort)."\",
			user_photo_view_sort = \"".cnv_sqlstr($user_photo_view_sort)."\",
			user_update_time = \"".cnv_sqlstr($user_update_time)."\"
			where user_id = ".cnv_sqlstr($user_id);
	return db_query($sql);
}

function db_update_user_template($user_id, $user_select_template,$user_update_time){
	$sql = "update user_table set ";
	$sql .= "user_select_template = \"".cnv_sqlstr($user_select_template)."\",
			user_update_time = \"".cnv_sqlstr($user_update_time)."\"
			where user_id = ".cnv_sqlstr($user_id);
	return db_query($sql);
}

function db_update_user_last_access_time($user_id, $user_last_access_time){
    $sql = "update user_table set ";
    $sql .= "user_last_access_time = \"".cnv_sqlstr($user_last_access_time)."\"
            where user_id = ".cnv_sqlstr($user_id);
    return db_query($sql);
}

function db_update_user_password($user_id, $user_pass, $user_update_time){
	$sql = "update user_table set ";
	$sql .= "user_pass = \"".md5(cnv_sqlstr($user_pass))."\", 
			user_update_time = \"".cnv_sqlstr($user_update_time)."\"
			where user_id = ".cnv_sqlstr($user_id);
	return db_query($sql);
}

function db_select_user_table(){
	$sql = "select * from user_table order by user_id";
	return db_query($sql);
}

function db_select_normal_user_table(){
	$sql = "select * from user_table
			where user_auth = \"USER\" or user_auth = \"GUEST\" order by user_id";
	return db_query($sql);
}

function db_select_admin_user_table(){
	$sql = "select * from user_table
			where user_auth = \"ADMIN\" order by user_id";
	return db_query($sql);
}

function db_select_user_id($user_id){
	$sql = "select * from user_table 
			where user_id = \"".cnv_sqlstr($user_id)."\"";
	return db_query($sql);
}

function db_check_this_month_first_login(){
    $sql = "select user_last_access_time, YEAR(NOW()) = YEAR(user_last_access_time) AND 
          MONTH(NOW()) = MONTH(user_last_access_time) as flag from user_table order by user_last_access_time DESC limit 1";
    return db_query($sql);
}

function db_del_user_id($user_id){
	$sql = "delete from user_table where (user_id = ".$user_id.")";
	return db_query($sql);
}

function db_create_cat_table(){
	$sql = "create table cat_table (
		cat_id INT UNSIGNED PRIMARY KEY AUTO_INCREMENT,
		cat_name VARCHAR(64) UNIQUE NOT NULL,
		cat_comment TEXT,
		cat_create_user_id INT UNSIGNED NOT NULL,
		cat_priority TINYINT UNSIGNED DEFAULT 10,
        cat_show_count BIGINT UNSIGNED DEFAULT 0,
        cat_show_count_month BIGINT UNSIGNED DEFAULT 0,
        cat_download_count BIGINT UNSIGNED DEFAULT 0,
		cat_create_time DATETIME,
		cat_update_time DATETIME
		)";
	return db_query($sql);
}

function db_drop_cat_table(){
    $sql = "drop table if exists cat_table";
    return db_query($sql);
}

function db_insert_cat($cat_name,$cat_comment, $cat_create_user_id, 
                    $cat_priority, $cat_show_count, $cat_show_count_month, $cat_download_count, $cat_create_time, $cat_update_time){
    $sql = "insert into cat_table (cat_name, cat_comment, cat_create_user_id, 
            cat_priority, cat_show_count, cat_show_count_month, cat_download_count, cat_create_time, cat_update_time)";
    $sql .= "values(\"".cnv_sqlstr($cat_name)."\", \""
                .cnv_sqlstr($cat_comment)."\", \""
                .cnv_sqlstr($cat_create_user_id)."\", \""
                .cnv_sqlstr($cat_priority)."\", \""
                .cnv_sqlstr($cat_show_count)."\", \""
                .cnv_sqlstr($cat_show_count_month)."\", \""
                .cnv_sqlstr($cat_download_count)."\", \""
                .cnv_sqlstr($cat_create_time)."\", \""
                .cnv_sqlstr($cat_update_time)."\")";
    return db_query($sql);
}

function db_select_cat(){
    global $CatSortPolicy;
    global $AuthObj;
    
    $sql = "select t1.*, t2.user_id, t2.user_name from cat_table as t1, user_table as t2 
            where t1.cat_create_user_id = t2.user_id order by t1.".$CatSortPolicy[$AuthObj->getAuthData("user_cat_view_sort")]["sql"];
    return db_query($sql);
}

function db_select_cat_access_user_id($user_id){
    global $CatSortPolicy;
    global $AuthObj;
    
	$sql = "select t1.*,t2.user_id, t2.user_name,t3.access_user_id, t3.access_cat_id 
			from cat_table as t1, user_table as t2, access_table as t3 
			where t1.cat_create_user_id = t2.user_id and t1.cat_id = t3.access_cat_id 
			and t3.access_user_id = ".$user_id." order by t1.".$CatSortPolicy[$AuthObj->getAuthData("user_cat_view_sort")]["sql"];
	return db_query($sql);
}

function db_select_cat_name($cat_name){
	$sql = "select * from cat_table 
			where cat_name = \"".cnv_sqlstr($cat_name)."\"";
	return db_query($sql);
}

function db_select_cat_id($cat_id){
	$sql = "select * from cat_table
			where cat_id = \"".cnv_sqlstr($cat_id)."\"";
	return db_query($sql);
}

function db_select_cat_create_user_id($user_id){
	$sql = "select * from cat_table
			where cat_create_user_id = \"".cnv_sqlstr($user_id)."\"";
	return db_query($sql);
}

function db_update_cat($cat_id, $cat_name, $cat_comment, $cat_create_user_id, $cat_update_time){
	$sql = "update cat_table set ";
	$sql .= "cat_name = \"".cnv_sqlstr($cat_name)."\", 
			cat_comment = \"".cnv_sqlstr($cat_comment)."\",
			cat_create_user_id = \"".cnv_sqlstr($cat_create_user_id)."\",
			cat_update_time = \"".cnv_sqlstr($cat_update_time)."\"
			where cat_id = ".cnv_sqlstr($cat_id);
	return db_query($sql);
}

function db_update_cat_show_count($cat_id){
    $sql = "update cat_table set ";
    $sql .= "cat_show_count = cat_show_count + 1, 
            cat_show_count_month = cat_show_count_month + 1
            where cat_id = ".cnv_sqlstr($cat_id);
    return db_query($sql); 
}

function db_update_cat_download_count($cat_id){
    $sql = "update cat_table set ";
    $sql .= "cat_download_count = cat_download_count + 1
            where cat_id = ".cnv_sqlstr($cat_id);
    return db_query($sql); 
}

function db_upadate_cat_show_count_month_clear(){
    $sql = "update cat_table set ";
    $sql .= "cat_show_count_month = 0";
    return db_query($sql);     
}

function db_del_cat_id($cat_id){
	$sql = "delete from cat_table where (cat_id = ".$cat_id.")";
	return db_query($sql);
}

function db_create_access_table(){
	$sql = "create table access_table (
		access_id INT UNSIGNED PRIMARY KEY AUTO_INCREMENT,
		access_user_id INT UNSIGNED NOT NULL,
		access_cat_id INT UNSIGNED NOT NULL,
		access_auth VARCHAR(10) NOT NULL,
		access_create_user_id INT UNSIGNED NOT NULL,
		access_priority TINYINT UNSIGNED DEFAULT 10
		)";
	return db_query($sql);
}

function db_drop_access_table(){
	$sql = "drop table if exists access_table";
	return db_query($sql);
}

function db_insert_access($access_user_id, $access_cat_id, 
                    $access_auth, $access_create_user_id, $access_priority){
    $sql = "insert into access_table (access_user_id, access_cat_id, access_auth, 
            access_create_user_id, access_priority)";
    $sql .= "values(\"".cnv_sqlstr($access_user_id)."\", \""
                .cnv_sqlstr($access_cat_id)."\", \""
                .cnv_sqlstr($access_auth)."\", \""
                .cnv_sqlstr($access_create_user_id)."\", \""
                .cnv_sqlstr($access_priority)."\")";
    return db_query($sql);
}

function db_select_access_all_cat_user_id($user_id){
	$sql ="select t1.cat_id, t1.cat_name, t1.cat_comment,
		t2.*, IF(t2.access_user_id,\"checked\",NULL) As access_ok 
		from cat_table as t1 left outer join 
		(select * from access_table where access_user_id = ".$user_id.") as t2 
		on t1.cat_id = t2.access_cat_id order by t1.cat_id";
	return db_query($sql);
}

function db_select_access(){
	$sql ="select t1.*, t2.cat_id, t2.cat_name, t2.cat_comment, 
		t3.user_id, t3.user_name from access_table as t1, cat_table as t2, user_table as t3 
		where t1.access_cat_id = t2.cat_id and t1.access_user_id = t3.user_id order by t3.user_id";
	return db_query($sql);
}

function db_select_access_user_id_cat_id($cat_id, $user_id){
    global $AuthObj;
    
	$sql = "select * from access_table 
			where access_cat_id = ".$cat_id." 
			and access_user_id = ".$user_id;
	return db_query($sql);
}

function db_del_access_id($access_id){
	$sql = "delete from access_table where (access_id = ".$access_id.")";
	return db_query($sql);
}

function db_del_access_user_id($user_id){
	$sql = "delete from access_table where (access_user_id = ".$user_id.")";
	return db_query($sql);
}

function db_del_access_cat_id($cat_id){
	$sql = "delete from access_table where (access_cat_id = ".$cat_id.")";
	return db_query($sql);
}

function db_create_album_list_table($cat_id){
	$sql = "create table album_list_table_".$cat_id." (
		album_id INT UNSIGNED PRIMARY KEY AUTO_INCREMENT,
		album_name VARCHAR(64) UNIQUE NOT NULL,
		album_comment TEXT,
		album_create_user_id INT UNSIGNED NOT NULL,
		album_priority TINYINT UNSIGNED DEFAULT 10,
        album_show_count BIGINT UNSIGNED DEFAULT 0,
        album_show_count_month BIGINT UNSIGNED DEFAULT 0,
        album_download_count BIGINT UNSIGNED DEFAULT 0,
		album_create_time DATETIME,
		album_update_time DATETIME
		)";
	return db_query($sql);
}

function db_drop_album_list_table($cat_id){
	$sql = "drop table if exists album_list_table_".$cat_id;
	return db_query($sql);
}

function db_insert_album_list($cat_id, $album_name,$album_comment, $album_create_user_id, 
					$album_priority, $album_show_count, $album_show_count_month, $album_download_count, $album_create_time, $album_update_time){
	$sql = "insert into album_list_table_".$cat_id." (album_name, album_comment, album_create_user_id, 
			album_priority, album_show_count, album_show_count_month, album_download_count, album_create_time, album_update_time)";
	$sql .= "values(\"".cnv_sqlstr($album_name)."\", \""
				.cnv_sqlstr($album_comment)."\", \""
				.cnv_sqlstr($album_create_user_id)."\", \""
				.cnv_sqlstr($album_priority)."\", \""
                .cnv_sqlstr($album_show_count)."\", \""
                .cnv_sqlstr($album_show_count_month)."\", \""
				.cnv_sqlstr($album_download_count)."\", \""
				.cnv_sqlstr($album_create_time)."\", \""
				.cnv_sqlstr($album_update_time)."\")";
	return db_query($sql);
}

function db_update_album_list($cat_id, $album_id, $album_name, $album_comment, $album_update_time){
	$sql = "update album_list_table_".$cat_id." set ";
	$sql .= "album_name = \"".cnv_sqlstr($album_name)."\", 
			album_comment = \"".cnv_sqlstr($album_comment)."\",
			album_update_time = \"".cnv_sqlstr($album_update_time)."\"
			where album_id = ".cnv_sqlstr($album_id);
	return db_query($sql);
}

function db_update_album_list_show_count($cat_id, $album_id){
    $sql = "update album_list_table_".$cat_id." set ";
    $sql .= "album_show_count = album_show_count + 1, 
            album_show_count_month = album_show_count_month + 1
            where album_id = ".cnv_sqlstr($album_id);
    return db_query($sql); 
}

function db_update_album_list_download_count($cat_id, $album_id){
    $sql = "update album_list_table_".$cat_id." set ";
    $sql .= "album_download_count = album_download_count + 1
            where album_id = ".cnv_sqlstr($album_id);
    return db_query($sql); 
}

function db_upadate_album_show_count_month_clear($cat_id){
    $sql = "update album_list_table_".$cat_id." set ";
    $sql .= "album_show_count_month = 0";
    return db_query($sql);
}

function db_select_album_list($cat_id){
    global $AlbumSortPolicy;
    global $AuthObj;
    
	$sql = "select t1.*,t2.user_id, t2.user_name as album_create_user_name 
			from album_list_table_".$cat_id." as t1, user_table as t2 
			where t1.album_create_user_id = t2.user_id order by t1.".$AlbumSortPolicy[$AuthObj->getAuthData("user_album_view_sort")]["sql"];
	return db_query($sql);
}

function db_select_album_create_user_id($cat_id, $user_id){
    $sql = "select t1.*, t2.user_id, t2.user_name as album_create_user_name
            from album_list_table_".$cat_id." as t1, user_table as t2 
            where t1.album_create_user_id = \"".cnv_sqlstr($user_id)."\" and t1.album_create_user_id = t2.user_id order by t1.album_id";
    return db_query($sql);
}

function db_select_album_name($cat_id, $album_name){
	$sql = "select * from album_list_table_".$cat_id."
			where album_name = \"".cnv_sqlstr($album_name)."\"";
	return db_query($sql);
}

function db_select_album_id($cat_id, $album_id){
	$sql = "select * from album_list_table_".$cat_id."
			where album_id = \"".cnv_sqlstr($album_id)."\"";
	return db_query($sql);
}

function db_del_album_id($cat_id, $album_id){
	$sql = "delete from album_list_table_".$cat_id." where (album_id = ".$album_id.")";
	return db_query($sql);
}

function db_del_album_name($cat_id, $album_name){
	$sql = "delete from album_list_table_".$cat_id." where (album_name = ".$album_name.")";
	return db_query($sql);
}

function db_create_photo_table($cat_id, $album_id){
	$sql = "create table photo_table_".$cat_id."_".$album_id." (
		photo_id INT UNSIGNED PRIMARY KEY AUTO_INCREMENT,
		photo_name VARCHAR(64) UNIQUE NOT NULL,
		photo_comment TEXT,
		photo_create_user_id INT UNSIGNED NOT NULL,
		photo_priority TINYINT UNSIGNED DEFAULT 10,
        photo_show_count BIGINT UNSIGNED DEFAULT 0,
        photo_show_count_month BIGINT UNSIGNED DEFAULT 0,
		photo_download_count BIGINT UNSIGNED DEFAULT 0,
		photo_size INT UNSIGNED,
		photo_width INT UNSIGNED,
		photo_height INT UNSIGNED,
		photo_thumb1_width INT UNSIGNED,
		photo_thumb1_height INT UNSIGNED,
		photo_thumb2_width INT UNSIGNED,
		photo_thumb2_height INT UNSIGNED,
		photo_thumb3_width INT UNSIGNED,
		photo_thumb3_height INT UNSIGNED,
		photo_thumb4_width INT UNSIGNED,
		photo_thumb4_height INT UNSIGNED,
		photo_mime_type TEXT,
		photo_original_time DATETIME,
		photo_camera_model TEXT,
		photo_exposure_time TEXT,
		photo_fnumber TEXT,
		photo_iso_speed_ratings TEXT,
		photo_create_time DATETIME,
		photo_update_time DATETIME
		)";
	return db_query($sql);
}

function db_drop_photo_table($cat_id, $album_id){
	$sql = "drop table if exists photo_table_".$cat_id."_".$album_id;
	return db_query($sql);
}

function db_insert_photo($cat_id, $album_id, $photo_name,$photo_comment, $photo_create_user_id, 
					$photo_priority, $photo_show_count, $photo_show_count_month, $photo_download_count, $photo_size, $photo_width, $photo_height, 
					$photo_thumb1_width, $photo_thumb1_height, $photo_thumb2_width, $photo_thumb2_height, 
					$photo_thumb3_width, $photo_thumb3_height, $photo_thumb4_width, $photo_thumb4_height, $photo_mime_type, 
					$photo_original_time, $photo_camera_model, $photo_exposure_time, $photo_fnumber,
					$photo_iso_speed_ratings, $photo_create_time, $photo_update_time){
	$sql = "insert into photo_table_".$cat_id."_".$album_id." (photo_name, photo_comment, photo_create_user_id, 
				photo_priority, photo_show_count, photo_show_count_month, photo_download_count, photo_size, 
				photo_width, photo_height, photo_thumb1_width, photo_thumb1_height, photo_thumb2_width, photo_thumb2_height, 
				photo_thumb3_width, photo_thumb3_height, photo_thumb4_width, photo_thumb4_height, photo_mime_type, 
				photo_original_time, photo_camera_model, photo_exposure_time, photo_fnumber,
				photo_iso_speed_ratings, photo_create_time, photo_update_time)";
	$sql .= "values(\"".cnv_sqlstr($photo_name)."\", \""
				.cnv_sqlstr($photo_comment)."\", \""
				.cnv_sqlstr($photo_create_user_id)."\", \""
				.cnv_sqlstr($photo_priority)."\", \""
                .cnv_sqlstr($photo_show_count)."\", \""
                .cnv_sqlstr($photo_show_count_month)."\", \""
				.cnv_sqlstr($photo_download_count)."\", \""
				.cnv_sqlstr($photo_size)."\", \""
				.cnv_sqlstr($photo_width)."\", \""
				.cnv_sqlstr($photo_height)."\", \""
				.cnv_sqlstr($photo_thumb1_width)."\", \""
				.cnv_sqlstr($photo_thumb1_height)."\", \""
				.cnv_sqlstr($photo_thumb2_width)."\", \""
				.cnv_sqlstr($photo_thumb2_height)."\", \""
				.cnv_sqlstr($photo_thumb3_width)."\", \""
				.cnv_sqlstr($photo_thumb3_height)."\", \""
				.cnv_sqlstr($photo_thumb4_width)."\", \""
				.cnv_sqlstr($photo_thumb4_height)."\", \""
				.cnv_sqlstr($photo_mime_type)."\", \""
				.cnv_sqlstr($photo_original_time)."\", \""
				.cnv_sqlstr($photo_camera_model)."\", \""
				.cnv_sqlstr($photo_exposure_time)."\", \""
				.cnv_sqlstr($photo_fnumber)."\", \""
				.cnv_sqlstr($photo_iso_speed_ratings)."\", \""
				.cnv_sqlstr($photo_create_time)."\", \""
				.cnv_sqlstr($photo_update_time)."\")";
	return db_query($sql);
}

function db_update_photo($cat_id, $album_id, $photo_id, $photo_comment, $photo_update_time){
	$sql = "update photo_table_".$cat_id."_".$album_id." set ";
	$sql .= "photo_comment = \"".cnv_sqlstr($photo_comment)."\",
			photo_update_time = \"".cnv_sqlstr($photo_update_time)."\"
			where photo_id = ".cnv_sqlstr($photo_id);
	return db_query($sql);
}

function db_update_photo_thmb($cat_id, $album_id, $photo_id, $photo_size, $photo_width, $photo_height, 
					$photo_thumb1_width, $photo_thumb1_height, $photo_thumb2_width, $photo_thumb2_height, 
					$photo_thumb3_width, $photo_thumb3_height, $photo_thumb4_width, $photo_thumb4_height, 
					$photo_mime_type, $photo_original_time, $photo_camera_model, $photo_exposure_time, $photo_fnumber,
					$photo_iso_speed_ratings, $photo_update_time){
	$sql = "update photo_table_".$cat_id."_".$album_id." set ";
	$sql .= "photo_size = \"".cnv_sqlstr($photo_size)."\",
			photo_width = \"".cnv_sqlstr($photo_width)."\",
			photo_height = \"".cnv_sqlstr($photo_height)."\",
			photo_thumb1_width = \"".cnv_sqlstr($photo_thumb1_width)."\",
			photo_thumb1_height = \"".cnv_sqlstr($photo_thumb1_height)."\",
			photo_thumb2_width = \"".cnv_sqlstr($photo_thumb2_width)."\",
			photo_thumb2_height = \"".cnv_sqlstr($photo_thumb2_height)."\",
			photo_thumb3_width = \"".cnv_sqlstr($photo_thumb3_width)."\",
			photo_thumb3_height = \"".cnv_sqlstr($photo_thumb3_height)."\",
			photo_thumb4_width = \"".cnv_sqlstr($photo_thumb4_width)."\",
			photo_thumb4_height = \"".cnv_sqlstr($photo_thumb4_height)."\",
			photo_mime_type = \"".cnv_sqlstr($photo_mime_type)."\",
			photo_original_time = \"".cnv_sqlstr($photo_original_time)."\",
			photo_camera_model = \"".cnv_sqlstr($photo_camera_model)."\",
			photo_exposure_time = \"".cnv_sqlstr($photo_exposure_time)."\",
			photo_fnumber = \"".cnv_sqlstr($photo_fnumber)."\",
			photo_iso_speed_ratings = \"".cnv_sqlstr(photo_iso_speed_ratings)."\",
			photo_update_time = \"".cnv_sqlstr($photo_update_time)."\"
			where photo_id = ".cnv_sqlstr($photo_id);
	return db_query($sql);
}

function db_update_photo_show_count($cat_id, $album_id, $photo_id){
    $sql = "update photo_table_".$cat_id."_".$album_id." set ";
    $sql .= "photo_show_count = photo_show_count + 1, 
            photo_show_count_month = photo_show_count_month + 1
            where photo_id = ".cnv_sqlstr($photo_id);
    return db_query($sql); 
}

function db_update_photo_download_count($cat_id, $album_id, $photo_id){
    $sql = "update photo_table_".$cat_id."_".$album_id." set ";
    $sql .= "photo_download_count = photo_download_count + 1
            where photo_id = ".cnv_sqlstr($photo_id);
    return db_query($sql); 
}

function db_upadate_photo_show_count_month_clear($cat_id, $album_id){
    $sql = "update photo_table_".$cat_id."_".$album_id." set ";
    $sql .= "photo_show_count_month = 0";
    return db_query($sql);     
}

function db_select_photo($cat_id, $album_id){
    global $PhotoSortPolicy;
    global $AuthObj;
    
	$sql = "select t1.*, t2.user_id, t2.user_name 
			from photo_table_".$cat_id."_".$album_id." as t1, user_table as t2 
			where t1.photo_create_user_id = t2.user_id order by t1.".$PhotoSortPolicy[$AuthObj->getAuthData("user_photo_view_sort")]["sql"];
	return db_query($sql);
}

function db_select_photo_limit($cat_id, $album_id, $limit){
	$sql = "select t1.*, t2.user_id, t2.user_name 
			from photo_table_".$cat_id."_".$album_id." as t1, user_table as t2 
			where t1.photo_create_user_id = t2.user_id order by t1.photo_id limit ".$limit;
	return db_query($sql);
}

function db_select_photo_id($cat_id, $album_id, $photo_id){
	$sql = "select * from photo_table_".$cat_id."_".$album_id." 
			where photo_id = \"".cnv_sqlstr($photo_id)."\"";
	return db_query($sql);
}

function db_del_photo_id($cat_id, $album_id, $photo_id){
	$sql = "delete from photo_table_".$cat_id."_".$album_id." where (photo_id = ".$photo_id.")";
	return db_query($sql);
}

function db_alter_photo_table_alpha2($cat_id, $album_id){
	$sql = "alter table photo_table_".$cat_id."_".$album_id." ADD photo_thumb1_width INT UNSIGNED";
	db_query($sql);
	$sql = "alter table photo_table_".$cat_id."_".$album_id." ADD photo_thumb1_height INT UNSIGNED";
	db_query($sql);
	$sql = "alter table photo_table_".$cat_id."_".$album_id." ADD photo_thumb2_width INT UNSIGNED";
	db_query($sql);
	$sql = "alter table photo_table_".$cat_id."_".$album_id." ADD photo_thumb2_height INT UNSIGNED";
	db_query($sql);
	$sql = "alter table photo_table_".$cat_id."_".$album_id." ADD photo_thumb3_width INT UNSIGNED";
	db_query($sql);
	$sql = "alter table photo_table_".$cat_id."_".$album_id." ADD photo_thumb3_height INT UNSIGNED";
	db_query($sql);
	$sql = "alter table photo_table_".$cat_id."_".$album_id." ADD photo_thumb4_width INT UNSIGNED";
	db_query($sql);
	$sql = "alter table photo_table_".$cat_id."_".$album_id." ADD photo_thumb4_height INT UNSIGNED";
	return db_query($sql);
}
?>